#!/usr/bin/env bash

kldload fuse.ko

if [ ! -d /mnt/llfuse ]; then
	mkdir -p /mnt/llfuse
fi

./hello_ll /mnt/llfuse &
sleep 0.1

if [ ! -f /mnt/llfuse/hello1 ]; then
	sleep 0.5
fi
if [ ! -f /mnt/llfuse/hello1 ]; then
	sleep 0.5
fi
if [ ! -f /mnt/llfuse/hello1 ]; then
	echo "Fuse not mounted !!!"
	exit
fi

# problem 1 (dentry cache)

echo "t1" >> /mnt/llfuse/hello1
sleep 0.1
echo "t2" >> /mnt/llfuse/hello2
sleep 0.1
echo "t3" >> /mnt/llfuse/hello1
sleep 0.1
echo "t4" >> /mnt/llfuse/hello2
sleep 0.1
echo "t5" >> /mnt/llfuse/hello1
sleep 0.1
echo "t6" >> /mnt/llfuse/hello2
sleep 0.1

echo
echo "hello1:"
cat /mnt/llfuse/hello1

echo
echo "hello2:"
cat /mnt/llfuse/hello2

echo
ls -al /mnt/llfuse/

# problem 2 (early release)

echo
echo "slow (10s) read ..."
time (
	dd if=/mnt/llfuse/slow_cached of=/dev/null bs=4k count=1 &
	sleep 1
	kill -9 $!
	wait
)

# problem 3 (I/O efficiency - block 4k)

echo
echo "read in classic (cached) mode:"
dd if=/mnt/llfuse/zero_cached of=/dev/null bs=1048576

echo
echo "read in direct (not cached and usually not recommended) mode:"
dd if=/mnt/llfuse/zero_direct of=/dev/null bs=1048576


# finish

umount /mnt/llfuse
